<template>
	<transition name="modal">
		<div ref="mask" class="modal-mask">
			<div ref="wrapper" class="modal-wrapper" @click="clickOnMask">
				<div class="modal-container">
					<div v-if="ShowClose" class="close" @click="$emit('close')">&times;</div>
					<slot></slot>
				</div>
			</div>
		</div>
	</transition>
</template>

<script>
export default {
	props: {
		ShowClose:{
			default: true
		}
	},
	data: function() {
		return {}
	},
	methods: {
		clickOnMask(event) {
			if (event.target.classList.contains('modal-wrapper')) {
				this.$emit('close')
			}
		}
	}
}
</script>

<style lang="scss" scoped>
.modal-mask {
	position: fixed;
	z-index: 9998;
	top: 0;
	left: 0;
	width: 100vw;
	height: 100vh;
	background-color: rgba(0, 0, 0, 0.5);
	display: table;
	transition: opacity 0.3s ease;
	.modal-wrapper {
		display: table-cell;
		vertical-align: middle;
		.modal-container {
			width: 300px;
			margin: 0px auto;
			padding: 20px 10px;
			background-color: #fff;
			border-radius: 5px;
			box-shadow: 0 2px 8px rgba(0, 0, 0, 0.33);
			transition: all 0.3s ease;
			font-family: Helvetica, Arial, sans-serif;

			.close {
				font-weight: 800;
				color: #646979;
				font-size: 22px;
				float: right;
				margin-top: -4%;
			}
		}
	}
}
</style>
